import { AfterViewInit, OnInit, OnDestroy, EventEmitter } from '@angular/core';
import { Widget } from '../typed-base-widget';
import { InstantSearchOptions, InstantSearch } from 'instantsearch.js/es/types';
export { SearchClient, Hit } from 'instantsearch.js/es/types';
export { PlainSearchParameters as SearchParameters, } from 'algoliasearch-helper';
export declare type FacetSortByStringOptions = 'count' | 'count:asc' | 'count:desc' | 'name' | 'name:asc' | 'name:desc' | 'isRefined';
export declare type InstantSearchConfig = InstantSearchOptions;
export declare type InstantSearchInstance = InstantSearch;
export declare class NgAisInstantSearch implements AfterViewInit, OnInit, OnDestroy {
    platformId: Object;
    config: InstantSearchConfig;
    instanceName: string;
    change: EventEmitter<{
        results: {};
        state: {};
    }>;
    instantSearchInstance: InstantSearchInstance;
    constructor(platformId: Object);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    addWidgets(widgets: Widget[]): void;
    removeWidgets(widgets: Widget[]): void;
    refresh(): void;
    onRender: () => void;
}
