import { EventEmitter, AfterViewInit, ElementRef, DoCheck } from '@angular/core';
import { TypedBaseWidget } from '../typed-base-widget';
import { NgAisInstantSearch } from '../instantsearch/instantsearch';
import { NgAisIndex } from '../index-widget/index-widget';
import { SearchBoxConnectorParams, SearchBoxWidgetDescription, SearchBoxRenderState } from 'instantsearch.js/es/connectors/search-box/connectSearchBox';
export declare class NgAisSearchBox extends TypedBaseWidget<SearchBoxWidgetDescription, SearchBoxConnectorParams> implements AfterViewInit, DoCheck {
    parentIndex: NgAisIndex;
    instantSearchInstance: NgAisInstantSearch;
    private injectedDocument;
    searchBox: ElementRef;
    placeholder: string;
    submitTitle: string;
    resetTitle: string;
    searchAsYouType: boolean;
    autofocus: boolean;
    showLoadingIndicator: boolean;
    submit: EventEmitter<any>;
    reset: EventEmitter<any>;
    change: EventEmitter<any>;
    focus: EventEmitter<any>;
    blur: EventEmitter<any>;
    query: string;
    state: SearchBoxRenderState;
    private document;
    constructor(parentIndex: NgAisIndex, instantSearchInstance: NgAisInstantSearch, injectedDocument: Document);
    ngAfterViewInit(): void;
    ngDoCheck(): void;
    handleChange(query: string): void;
    handleSubmit(event: Event): void;
    handleReset(event: MouseEvent): void;
}
